#include "AneuMeshLoader.h"
#include <fstream>
#include "Exceptions.h"

void AneuMeshLoader::loadMesh(const std::string& str) {
	std::ifstream file(str);

	if (!file) {
		throw FileIsNotFound(str);
	}

	int n, k, c;
	double c2;
	file >> n>>k;
	for (int i = 1; i <= n; i++) {
		Node a;
		a.ID_Node = i;
		for (int j = 1; j <= k; j++) {
			file >> c2;
			a.Coordin.push_back(c2);
		}
		a.flag = true;
		m_Node.push_back(std::move(a));                 //!!! std::move 
	}

	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		FiniteElement a;
		a.ID_KE = i;
		file >> a.ID_Material;
		for (int j = 1; j <= k; j++) {
			file >> c;
			a.ID_Nodes.push_back(c);
		}
		m_FiniteElement.push_back(std::move(a));         //!!! std::move 
	}

	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		BoundaryFiniteElement a;
		a.ID_Element = i;
		file >> a.ID_Border;
		for (int j = 1; j <= k; j++) {
			file >> c;
			a.ID_Nodes.push_back(c);
		}
		m_BoundaryFiniteElement.push_back(std::move(a));           //!!! std::move 
	}

	file.close();
}